%define anolis_release 3
%bcond_without check

Name:          python-argcomplete
Summary:       Bash tab completion for argparse
Version:       2.0.0
Release:       %{anolis_release}%{?dist}
License:       ASL 2.0
URL:           https://github.com/kislyuk/argcomplete
Source0:       %pypi_source argcomplete

# Fish in Fedora contains git hash in version which breaks tests,
# this patch removes it
Patch1:        0001-Remove-commit-hash-from-Fish-version.patch

BuildRequires: python3-devel

%if %{with check}
BuildRequires: tcsh
BuildRequires: fish
BuildRequires: /usr/bin/pip
BuildRequires: python3-pexpect
%endif

BuildArch:     noarch

%global _description %{expand:
Argcomplete provides easy, extensible command line tab completion of
arguments for your Python script.

It makes two assumptions:

 * You are using bash as your shell
 * You are using argparse to manage your command line arguments/options

Argcomplete is particularly useful if your program has lots of
options or subparsers, and if your program can dynamically suggest
completions for your argument/option values (for example, if the user
is browsing resources over the network).}

%description %_description

%package -n python3-argcomplete
Summary:        %{summary}
%description -n python3-argcomplete %_description

%package doc
Summary:        Documentation files for %{name}
Requires:       python3-argcomplete = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n argcomplete-%{version}
# Remove useless BRs
sed -i -r -e '/tests_require = /s/"(coverage|flake8|wheel)"[, ]*//g' setup.py

# https://github.com/kislyuk/argcomplete/issues/255
# https://github.com/kislyuk/argcomplete/issues/256
sed -i -e "1s|#!.*python.*|#!%{__python3}|" test/prog scripts/*
sed -i -e "s|python |python3 |" test/test.py

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install
mkdir -p %{buildroot}%{_sysconfdir}/bash_completion.d/
install -p -m0644 %{buildroot}%{python3_sitelib}/argcomplete/bash_completion.d/python-argcomplete %{buildroot}%{_sysconfdir}/bash_completion.d/

%generate_compatibility_deps

%if %{with check}
%check
# upstream: https://github.com/kislyuk/argcomplete/issues/337
echo "set enable-bracketed-paste off" > .inputrc
export INPUTRC=$PWD/.inputrc

%{python3} setup.py test
%endif

%files -n python3-argcomplete
%dir %{abidir}
%license LICENSE.rst
%{python3_sitelib}/argcomplete-%{version}.dist-info/
%{python3_sitelib}/argcomplete/
%{_bindir}/activate-global-python-argcomplete
%{_bindir}/python-argcomplete-check-easy-install-script
%{_bindir}/python-argcomplete-tcsh
%{_bindir}/register-python-argcomplete
%{abidir}/*python-argcomplete*-option.list
%{_sysconfdir}/bash_completion.d/python-argcomplete

%files doc
%doc README.rst

%changelog
* Mon Feb 27 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.0.0-3
- optimise dependency

* Thu Oct 13 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.0.0-2
- optimise spec file & add doc package

* Fri May 20 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.0.0-1
- init from upstream
